package com.hongyegroup.cpt_ewallet.ui

import android.os.Bundle
import com.guadou.cs_cptservices.base.fragment.YYBaseVDBFragment
import com.guadou.cs_cptservices.interfaces.IFragmentRefresh
import com.guadou.lib_baselib.bean.DataBindingConfig
import com.guadou.lib_baselib.engine.toast
import com.hongyegroup.cpt_ewallet.BR
import com.hongyegroup.cpt_ewallet.R
import com.hongyegroup.cpt_ewallet.databinding.FragmentEwalletMainBinding
import com.hongyegroup.cpt_ewallet.mvvm.EWalletMainViewModel

/**
 * 首页5页面之一 钱包的页面
 */
class EWalletMainFragment : YYBaseVDBFragment<EWalletMainViewModel, FragmentEwalletMainBinding>(), IFragmentRefresh {

    override fun getDataBindingConfig(): DataBindingConfig {
        return DataBindingConfig(R.layout.fragment_ewallet_main, BR.viewModel, mViewModel)
            .addBindingParams(BR.click, ClickProxy())
    }

    override fun startObserve() {
    }

    override fun init(savedInstanceState: Bundle?) {
        setStatusBarBlackText()
    }

    override fun scrollTopRefresh() {
        toast("EWalletMainFragment - scrollTopRefresh")
    }

    /**
     * DataBinding事件处理
     */
    inner class ClickProxy {

        //去提现
        fun gotoWithdrawal() {
            EWalletWithdrawalActivity.startInstance()
        }

        //去工资卡
        fun gotoSalaryCard() {
            EWalletSalaryCardActivity.startInstance()
        }

        //去历史页面
        fun gotoHistory() {
            EWalletHistoryActivity.startInstance()
        }
    }

}