package com.hongyegroup.cpt_ewallet.ui

import android.annotation.SuppressLint
import android.content.Intent
import android.os.Bundle
import com.guadou.cs_cptservices.base.activity.YYBaseVDBActivity
import com.guadou.lib_baselib.bean.DataBindingConfig
import com.guadou.lib_baselib.engine.toast
import com.guadou.lib_baselib.ext.countDown
import com.guadou.lib_baselib.utils.CommUtils
import com.guadou.lib_baselib.utils.KeyboardUtils
import com.hongyegroup.cpt_ewallet.BR
import com.hongyegroup.cpt_ewallet.R
import com.hongyegroup.cpt_ewallet.databinding.ActivityWithdrawalVerifyBinding
import com.hongyegroup.cpt_ewallet.mvvm.WithdrawalVerifyViewModel
import dagger.hilt.android.AndroidEntryPoint
import kotlinx.coroutines.CoroutineScope
import kotlinx.coroutines.ExperimentalCoroutinesApi
import kotlinx.coroutines.cancel

@AndroidEntryPoint
class WithdrawalVerifyActivity : YYBaseVDBActivity<WithdrawalVerifyViewModel, ActivityWithdrawalVerifyBinding>() {

    private var mCountDownScope: CoroutineScope? = null

    companion object {
        fun startInstance() {
            val context = CommUtils.getContext()
            val intent = Intent(context, WithdrawalVerifyActivity::class.java)
            intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
            context.startActivity(intent)
        }
    }

    override fun getDataBindingConfig(): DataBindingConfig {
        return DataBindingConfig(R.layout.activity_withdrawal_verify, BR.viewModel, mViewModel)
            .addBindingParams(BR.click, ClickProxy())
    }

    override fun init(savedInstanceState: Bundle?) {
        setStatusBarBlackText()
    }

    override fun startObserve() {

    }

    //开始倒计时
    @ExperimentalCoroutinesApi
    @SuppressLint("SetTextI18n")
    private fun startCountDown() {

        countDown(59, start = {
            mCountDownScope = it
        }, end = {
            mBinding.tvGetCode.apply {
                isEnabled = true
                text = "获取验证码"
            }
        }, next = {
            mBinding.tvGetCode.apply {
                isEnabled = false
                text = "重新获取($it)"
            }
        })
    }

    override fun onDestroy() {
        mCountDownScope?.cancel()
        super.onDestroy()
    }

    /**
     * DataBinding事件处理
     */
    inner class ClickProxy {

        fun gotoNext() {
            KeyboardUtils.hideSoftInput(mActivity)
            WithdrawalSuccessActivity.startInstance()
            finish()
        }

        //获取短信验证码
        @ExperimentalCoroutinesApi
        fun getVerityCode() {
            KeyboardUtils.hideSoftInput(mActivity)
            toast("获取短信验证码")
            startCountDown()
        }

    }

}